/*
 *	xmole.c : mole hitting game on X11 ( Version 1.0 ).
 *
 *	Copyright(C) 1989 MUKAWA.SUSUMU (mukawa@tn-sec.ntt.JUNET)
 *
 *	Permit anyone to use, modify, redistribute this software.
 */
char RCSid[] = "$Header: xmole.c,v 1.1 89/12/14 11:21:55 mukawa Exp $";

#include	<stdio.h>
#include	<X11/Intrinsic.h>
#include	<X11/StringDefs.h>
#include	<X11/Shell.h>
#include	<X11/Box.h>
#include	<X11/Label.h>
#include	<X11/Command.h>
#include	<X11/Form.h>
#include	"hellow.bm"
#include	"deru.bm"
#include	"ana.bm"
#include	"hit.bm"
#include	"ushiro.bm"
#include	"grass.bm"
#include	"gameover.bm"

extern long		time();
extern long		random();

Widget			topLevel, base, ground;
Widget			hiscore, nowscore, resttime;
Widget			speedbox, speed, speeddown, speedup;
Widget			start, stop, quit;
GC			moguraGC, deruGC, anaGC, hitGC, grassGC, gameoverGC;
Display			*myDisp;
static unsigned long	intTime = 3000;
static XtIntervalId	intID;
static XtIntervalId	restTimeID;
static int		gameTime = 10;
static int		focus = 10;
static int		hellowPos = -1;
static int		startFlag = 0;
static int		hitFlag = 0;
static int		hitPoint = 10;
static int		misPoint = 5;
static int		scoreNum, hiScoreNum;
static int		anaNum = 15;
static int		yokoAna = 5;
static int		tateAna = 3;

#define	GETXPOS(p)	((p % yokoAna) * 100 + (((p / yokoAna) % 2) ? 70 : 20))
#define	GETYPOS(p)	((p / yokoAna) * 100 + 20)

#define	GETGXPOS(p)	((p % yokoAna) * 100 + (((p / yokoAna) % 2) ? 40 : 90))
#define	GETGYPOS(p)	((p / yokoAna) * 100 + 40)

CalcHitPoint()
{
	if(intTime)
		hitPoint = (anaNum * 40) / (intTime / 200);
	else
		hitPoint = (anaNum * 40) * 2;
	misPoint = hitPoint / 4;
}

CreateGraphicContext(w)
Widget	w;
{
	Arg		args[5];
	Cardinal	i;
	XGCValues	gcv;
	Pixmap		stip;
	XFontStruct	*myFont;

	i = 0;
	XtSetArg(args[i], XtNborderColor, 0);	++i;
	XtSetArg(args[i], XtNbackground, 0);	++i;
	XtGetValues(w, args, i);

	if((stip = XCreateBitmapFromData(myDisp, XtScreen(w)->root,
			ana_bits, ana_width, ana_height)) == NULL)
		XtError("I can't create bitmap(ana).");

	gcv.function	= GXcopy;
	gcv.foreground	= (unsigned long)args[0].value;
	gcv.background	= (unsigned long)args[1].value;
	gcv.stipple	= stip;
	gcv.plane_mask	= AllPlanes;
	gcv.fill_style	= FillOpaqueStippled;

	anaGC = XCreateGC(myDisp, XtScreen(w)->root,
			GCFunction|GCForeground|GCBackground|
			GCStipple|GCPlaneMask|GCFillStyle, &gcv);

	if((stip = XCreateBitmapFromData(myDisp, XtScreen(w)->root,
			deru_bits, deru_width, deru_height)) == NULL)
		XtError("I can't create bitmap(deru).");

	gcv.function	= GXcopy;
	gcv.foreground	= (unsigned long)args[0].value;
	gcv.background	= (unsigned long)args[1].value;
	gcv.stipple	= stip;
	gcv.plane_mask	= AllPlanes;
	gcv.fill_style	= FillOpaqueStippled;

	deruGC = XCreateGC(myDisp, XtScreen(w)->root,
			GCFunction|GCForeground|GCBackground|
			GCStipple|GCPlaneMask|GCFillStyle, &gcv);

	if((stip = XCreateBitmapFromData(myDisp, XtScreen(w)->root,
			hellow_bits, hellow_width, hellow_height)) == NULL)
		XtError("I can't create bitmap(hellow).");

	gcv.function	= GXcopy;
	gcv.foreground	= (unsigned long)args[0].value;
	gcv.background	= (unsigned long)args[1].value;
	gcv.stipple	= stip;
	gcv.plane_mask	= AllPlanes;
	gcv.fill_style	= FillOpaqueStippled;

	moguraGC = XCreateGC(myDisp, XtScreen(w)->root,
			GCFunction|GCForeground|GCBackground|
			GCStipple|GCPlaneMask|GCFillStyle, &gcv);

	if((stip = XCreateBitmapFromData(myDisp, XtScreen(w)->root,
			hit_bits, hit_width, hit_height)) == NULL)
		XtError("I can't create bitmap(hit).");

	gcv.function	= GXcopy;
	gcv.foreground	= (unsigned long)args[0].value;
	gcv.background	= (unsigned long)args[1].value;
	gcv.stipple	= stip;
	gcv.plane_mask	= AllPlanes;
	gcv.fill_style	= FillOpaqueStippled;

	hitGC = XCreateGC(myDisp, XtScreen(w)->root,
			GCFunction|GCForeground|GCBackground|
			GCStipple|GCPlaneMask|GCFillStyle, &gcv);

	if((stip = XCreateBitmapFromData(myDisp, XtScreen(w)->root,
			grass_bits, grass_width, grass_height)) == NULL)
		XtError("I can't create bitmap(grass).");

	gcv.function	= GXcopy;
	gcv.foreground	= (unsigned long)args[0].value;
	gcv.background	= (unsigned long)args[1].value;
	gcv.stipple	= stip;
	gcv.plane_mask	= AllPlanes;
	gcv.fill_style	= FillOpaqueStippled;

	grassGC = XCreateGC(myDisp, XtScreen(w)->root,
			GCFunction|GCForeground|GCBackground|
			GCStipple|GCPlaneMask|GCFillStyle, &gcv);

	if((stip = XCreateBitmapFromData(myDisp, XtScreen(w)->root,
			gameover_bits, gameover_width, gameover_height))
			== NULL)
		XtError("I can't create bitmap(gameover).");

	gcv.function	= GXcopy;
	gcv.foreground	= (unsigned long)args[0].value;
	gcv.background	= (unsigned long)args[1].value;
	gcv.stipple	= stip;
	gcv.plane_mask	= AllPlanes;
	gcv.fill_style	= FillOpaqueStippled;

	gameoverGC = XCreateGC(myDisp, XtScreen(w)->root,
			GCFunction|GCForeground|GCBackground|
			GCStipple|GCPlaneMask|GCFillStyle, &gcv);
}

XtCallbackProc	ResizeGround(w, event, params, nparams)
Widget		w;
XEvent		*event;
String		*params;
Cardinal	*nparams;
{
	Arg		args[2];

	XtSetArg(args[0], XtNwidth, 0);
	XtSetArg(args[1], XtNheight, 0);
	XtGetValues(w, args, 2);

	yokoAna = (args[0].value - 50) / 100;
	tateAna = args[1].value / 100;
	anaNum = yokoAna * tateAna;

	CalcHitPoint();

	RedrawGroundSub();
}

XtCallbackProc	RedrawGround(w, event, params, nparams)
Widget		w;
XEvent		*event;
String		*params;
Cardinal	*nparams;
{
	RedrawGroundSub();
}

RedrawGroundSub()
{
	XGCValues	gcv;
	int		i, x, y;

	for(i = 0; i < anaNum; ++i) {
		gcv.ts_x_origin	= x = GETXPOS(i);
		gcv.ts_y_origin	= y = GETYPOS(i);
		XChangeGC(myDisp, anaGC, GCTileStipXOrigin|GCTileStipYOrigin,
				&gcv);
		XFillRectangle(myDisp, XtWindow(ground), anaGC, x, y,
				ana_width, ana_height);
	}

	for(i = 0; i < anaNum; ++i) {
		gcv.ts_x_origin	= x = GETGXPOS(i);
		gcv.ts_y_origin	= y = GETGYPOS(i);
		XChangeGC(myDisp, grassGC, GCTileStipXOrigin|GCTileStipYOrigin,
				&gcv);
		XFillRectangle(myDisp, XtWindow(ground), grassGC, x, y,
				grass_width, grass_height);
	}
}

DrawGameOver()
{
	XGCValues	gcv;
	int		i, x, y;

	for(i = 0; i < anaNum; ++i) {
		gcv.ts_x_origin	= x = GETXPOS(i);
		gcv.ts_y_origin	= y = GETYPOS(i);
		XChangeGC(myDisp, gameoverGC,
				GCTileStipXOrigin|GCTileStipYOrigin, &gcv);
		XFillRectangle(myDisp, XtWindow(ground), gameoverGC, x, y,
				gameover_width, gameover_height);
	}
}

UpdateScore(sc)
int	sc;
{
	Arg		args[2];
	char		buf[16+1];

	sprintf(buf, "SCORE    : %05d", sc);
	XtSetArg(args[0], XtNlabel, buf);
	XtSetValues(nowscore, args, 1);
}

UpdateHiScore(sc)
int	sc;
{
	Arg		args[2];
	char		buf[16+1];

	sprintf(buf, "HI-SCORE : %05d", sc);
	XtSetArg(args[0], XtNlabel, buf);
	XtSetValues(hiscore, args, 1);
}

UpdateRest(res)
int	res;
{
	Arg		args[2];
	char		buf[15+1];

	sprintf(buf, "REST-TIME:   %02d", res);
	XtSetArg(args[0], XtNlabel, buf);
	XtSetValues(resttime, args, 1);
}

UpdateSpeed(spd)
int	spd;
{
	Arg		args[2];
	char		buf[15+1];

	sprintf(buf, "SPEED    :   %02d", spd);
	XtSetArg(args[0], XtNlabel, buf);
	XtSetValues(speed, args, 1);
}

XtCallbackProc	HitMogura(w, event, params, nparams)
Widget		w;
XEvent		*event;
String		*params;
Cardinal	*nparams;
{
	XGCValues	gcv;
	int		x, y;

	if(!hitFlag && hellowPos != -1) {
		x = GETXPOS(hellowPos);
		y = GETYPOS(hellowPos);
		if(event->xbutton.x >= x +focus &&
				event->xbutton.x <= x + hellow_width - focus &&
				event->xbutton.y >= y + focus &&
				event->xbutton.y <= y + hellow_height - focus) {
			/* HIT MOGURA !!
			 */
			XBell(myDisp, 0);
			gcv.ts_x_origin	= x;
			gcv.ts_y_origin	= y;
			XChangeGC(myDisp, hitGC,
					GCTileStipXOrigin|GCTileStipYOrigin,
					&gcv);
			XFillRectangle(myDisp, XtWindow(ground), hitGC, x, y,
					hit_width, hit_height);
			hitFlag = 1;
			scoreNum += hitPoint;
			UpdateScore(scoreNum);
		}
		else {
			/* if MIS SHOT !!
			 */
			scoreNum -= misPoint;
			UpdateScore(scoreNum);
		}
	}
}

XtTimerCallbackProc	HellowMogura(clientData, id)
caddr_t			clientData;
XtIntervalId		id;
{
	XGCValues		gcv;
	XtTimerCallbackProc	GoodbyMogura();
	XtTimerCallbackProc	KanzenHellowMogura();
	int			x, y;

	hitFlag = 0;
	hellowPos = random() % anaNum;

	gcv.ts_x_origin = x = GETXPOS(hellowPos);
	gcv.ts_y_origin = y = GETYPOS(hellowPos);
	XChangeGC(myDisp, deruGC, GCTileStipXOrigin|GCTileStipYOrigin, &gcv);
	XFillRectangle(myDisp, XtWindow(ground), deruGC, x, y,
			deru_width, deru_height);

	if(gameTime > 0)
		intID = XtAddTimeOut(intTime/(3*2), KanzenHellowMogura, 0);
}

XtTimerCallbackProc	KanzenHellowMogura(clientData, id)
caddr_t			clientData;
XtIntervalId		id;
{
	XGCValues	gcv;
	int		x, y;

	if(!hitFlag) {
		gcv.ts_x_origin = x = GETXPOS(hellowPos);
		gcv.ts_y_origin = y = GETYPOS(hellowPos);
		XChangeGC(myDisp,moguraGC, GCTileStipXOrigin|GCTileStipYOrigin,
				&gcv);
		XFillRectangle(myDisp, XtWindow(ground), moguraGC, x, y,
				hellow_width, hellow_height);
	}

	if(gameTime > 0)
		intID = XtAddTimeOut(intTime/(3*2), GoodbyMogura, 0);
}

XtTimerCallbackProc	GoodbyMogura(clientData, id)
caddr_t			clientData;
XtIntervalId		id;
{
	XGCValues	gcv;
	int		x, y;

	gcv.ts_x_origin = x = GETXPOS(hellowPos);
	gcv.ts_y_origin = y = GETYPOS(hellowPos);
	XChangeGC(myDisp, anaGC, GCTileStipXOrigin|GCTileStipYOrigin, &gcv);
	XFillRectangle(myDisp, XtWindow(ground), anaGC, x, y,
			ana_width, ana_height);
	hellowPos = -1;

	if(gameTime > 0)
		intID = XtAddTimeOut((intTime*2)/3, HellowMogura, 0);
}

static void	DownSpeed(w, closure, call_data)
Widget		w;
caddr_t		closure;
caddr_t		call_data;
{
	intTime += 200;
	UpdateSpeed(intTime/200);
	CalcHitPoint();
}

static void	UpSpeed(w, closure, call_data)
Widget		w;
caddr_t		closure;
caddr_t		call_data;
{
	if(intTime > 0) {
		intTime -= 200;
		UpdateSpeed(intTime/200);
		CalcHitPoint();
	}
	else
		XBell(myDisp, 0);
}

XtTimerCallbackProc	CountDown(clientData, id)
caddr_t			clientData;
XtIntervalId		id;
{
	--gameTime;
	UpdateRest(gameTime);
	if(gameTime > 0)
		restTimeID = XtAddTimeOut(1000, CountDown, 0);
	else {
		/* GAME OVER !!
		 */
		XtRemoveTimeOut(intID);
		DrawGameOver();
		if(hellowPos != -1)
			hellowPos = -1;
		if(hiScoreNum < scoreNum) {
			hiScoreNum = scoreNum;
			UpdateHiScore(hiScoreNum);
		}
		startFlag = 0;
	}
}

static void	StartGame(w, closure, call_data)
Widget		w;
caddr_t		closure;
caddr_t		call_data;
{
	if(!startFlag) {
		startFlag = 1;
		scoreNum = 0;
		gameTime = 30;
		UpdateScore(scoreNum);
		UpdateRest(gameTime);
		RedrawGroundSub();
		intID = XtAddTimeOut(intTime, HellowMogura, 0);
		restTimeID = XtAddTimeOut(1000, CountDown, 0);
	}
	else
		XBell(myDisp, 0);
}

static void	StopGame(w, closure, call_data)
Widget		w;
caddr_t		closure;
caddr_t		call_data;
{
	if(startFlag) {
		XtRemoveTimeOut(intID);
		XtRemoveTimeOut(restTimeID);
		RedrawGroundSub();
		hellowPos = -1;
		startFlag = 0;
	}
	else {
		RedrawGroundSub();
		XBell(myDisp, 0);
	}
}

static void	ExitProgram(w, closure, call_data)
Widget		w;
caddr_t		closure;
caddr_t		call_data;
{
	if(!startFlag) {
		XtUnmapWidget(topLevel);
		XtDestroyWidget(topLevel);
		exit(0);
	}
	else
		XBell(myDisp, 0);
}

main(ac, av)
int	ac;
char	**av;
{
	Arg			args[10];
	static XtCallbackRec	callback[2];
	Cardinal		i;
	XtTranslations		newTranslations;
	static XtActionsRec	redrawAction[] = {
				{"expose", (XtCallbackProc)RedrawGround},
				{"configure", (XtCallbackProc)ResizeGround},
				{"button1", (XtCallbackProc)HitMogura}};
	static char		*overrideTranslations =
				"<Expose>:	expose()\n\
				 <Configure>:	configure()\n\
				 <Btn1Down>:	button1()";

	srandom((int)time(0) %231);

	topLevel = XtInitialize(*av, "XMole", NULL, 0, &ac, av);

	myDisp = XtDisplay(topLevel);

	i = 0;
	XtSetArg(args[i], XtNiconPixmap,
			XCreateBitmapFromData(myDisp,
			XtScreen(topLevel)->root,
			ushiro_bits, ushiro_width, ushiro_height));	++i;
	XtSetValues(topLevel, args, i);

	base = XtCreateManagedWidget("base",formWidgetClass, topLevel, NULL, 0);

	i = 0;
	XtSetArg(args[i], XtNlabel, "HI-SCORE : 00000");	++i;
	XtSetArg(args[i], XtNheight, 50);			++i;
	hiscore = XtCreateManagedWidget("hi-score", labelWidgetClass, base,
			args, i);

	i = 0;
	XtSetArg(args[i], XtNlabel, "SCORE    : 00000");	++i;
	XtSetArg(args[i], XtNfromHoriz, hiscore);		++i;
	XtSetArg(args[i], XtNheight, 50);			++i;
	nowscore = XtCreateManagedWidget("nowscore", labelWidgetClass, base,
			args, i);

	i = 0;
	XtSetArg(args[i], XtNlabel, "REST-TIME:   30");	++i;
	XtSetArg(args[i], XtNfromHoriz, nowscore);	++i;
	XtSetArg(args[i], XtNheight, 50);		++i;
	resttime = XtCreateManagedWidget("rest", labelWidgetClass, base,
			args, i);

	i = 0;
	XtSetArg(args[i], XtNfromHoriz, resttime);	++i;
	XtSetArg(args[i], XtNheight, 50);		++i;
	speedbox = XtCreateManagedWidget("speedbox", boxWidgetClass, base,
			args, i);

	i = 0;
	XtSetArg(args[i], XtNlabel, "SPEED    :   15");	++i;
	speed = XtCreateManagedWidget("speed", labelWidgetClass, speedbox,
			args, i);

	i = 0;
	callback[0].callback = DownSpeed;
	callback[0].closure = (caddr_t)0;
	XtSetArg(args[i], XtNcallback, callback);	++i;
	XtSetArg(args[i], XtNlabel, "-");		++i;
	XtSetArg(args[i], XtNhighlightThickness, 100);	++i;
	speeddown = XtCreateManagedWidget("speed-down", commandWidgetClass,
			speedbox, args, i);

	i = 0;
	callback[0].callback = UpSpeed;
	callback[0].closure = (caddr_t)0;
	XtSetArg(args[i], XtNcallback, callback);	++i;
	XtSetArg(args[i], XtNlabel, "+");		++i;
	XtSetArg(args[i], XtNhighlightThickness, 100);	++i;
	speedup = XtCreateManagedWidget("speed-up", commandWidgetClass,
			speedbox, args, i);

	i = 0;
	callback[0].callback = StartGame;
	callback[0].closure = (caddr_t)0;
	XtSetArg(args[i], XtNcallback, callback);	++i;
	XtSetArg(args[i], XtNlabel, "START");		++i;
	XtSetArg(args[i], XtNheight, 50);		++i;
	XtSetArg(args[i], XtNfromHoriz, speedbox);	++i;
	XtSetArg(args[i], XtNhighlightThickness, 200);	++i;
	start = XtCreateManagedWidget("start", commandWidgetClass, base,
			args, i);
	i = 0;
	callback[0].callback = StopGame;
	callback[0].closure = (caddr_t)0;
	XtSetArg(args[i], XtNcallback, callback);	++i;
	XtSetArg(args[i], XtNlabel, "STOP");		++i;
	XtSetArg(args[i], XtNheight, 50);		++i;
	XtSetArg(args[i], XtNfromHoriz, start);		++i;
	XtSetArg(args[i], XtNhighlightThickness, 200);	++i;
	stop = XtCreateManagedWidget("stop", commandWidgetClass, base,
			args, i);

	i = 0;
	callback[0].callback = ExitProgram;
	callback[0].closure = (caddr_t)0;
	XtSetArg(args[i], XtNcallback, callback);	++i;
	XtSetArg(args[i], XtNlabel, "QUIT");		++i;
	XtSetArg(args[i], XtNheight, 50);		++i;
	XtSetArg(args[i], XtNfromHoriz, stop);		++i;
	XtSetArg(args[i], XtNhighlightThickness, 200);	++i;
	quit = XtCreateManagedWidget("quit", commandWidgetClass, base,
			args, i);

	i = 0;
	XtSetArg(args[i], XtNwidth, 550);	++i;
	XtSetArg(args[i], XtNheight, 300);	++i;
	XtSetArg(args[i], XtNborderWidth, 2);	++i;
	XtSetArg(args[i], XtNfromVert, hiscore);++i;
	ground = XtCreateManagedWidget("ground", boxWidgetClass, base, args, i);

	CreateGraphicContext(ground);

	XtAddActions(redrawAction, XtNumber(redrawAction));
	newTranslations = XtParseTranslationTable(overrideTranslations);
	XtOverrideTranslations(ground, newTranslations);

	XtRealizeWidget(topLevel);
	XtMainLoop();
}
